// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 7-Aug-1997
// 
#ifndef MATRIXWRAPPER_H
#define MATRIXWRAPPER_H
#include <stk.h>
#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/stkWrapper.h>
#include <LINK/basic/Matrix.h>
template <class Item> class MatrixWrapper {
public:
	static void 		markTypedMatrix(SCM p);
	static void 		freeTypedMatrix(SCM p);
	static void 		displayTypedMatrix(SCM c,SCM port,int mode);
	static PRIMITIVE	linkMatrixP(SCM l);
	static PRIMITIVE	makeLinkMatrix(SCM i, SCM j);
	static PRIMITIVE	makeFilledLinkMatrix(SCM row, SCM col, SCM e);
	static PRIMITIVE	fillLinkMatrix(SCM l, SCM e);
	static PRIMITIVE	copyLinkMatrix(SCM l);
	static PRIMITIVE 	stkList2LinkMatrix(SCM l, int len);
	static PRIMITIVE 	linkMatrix2STkList(SCM l);
	static PRIMITIVE	numRowsLinkMatrix(SCM l);
	static PRIMITIVE	numColsLinkMatrix(SCM l);
	static PRIMITIVE	eqvLinkMatrix(SCM l, SCM l2);
	static PRIMITIVE	setLinkMatrix(SCM alist, int len);
	static PRIMITIVE	refLinkMatrix(SCM l, SCM i, SCM j);
	static PRIMITIVE	multiply(SCM, SCM);
	static PRIMITIVE	scalarMultRow(SCM, SCM, SCM);
	static PRIMITIVE	scalarMultCol(SCM, SCM, SCM);
	static PRIMITIVE	swapRows(SCM, SCM, SCM);
	static PRIMITIVE	swapCols(SCM, SCM, SCM);
	static PRIMITIVE	addRows(SCM, SCM, SCM);
	static PRIMITIVE	addCols(SCM, SCM, SCM);
	static PRIMITIVE	sum(SCM, SCM);
	static PRIMITIVE	transpose(SCM);
	static double		getNumber(SCM e);
private:
	static Bool 		isMatrix (SCM p);
	static Matrix<Item>* 	getMatrix(SCM p);
};
//#ifdef DEFINE_MatrixWrapper_TEMPLATE
#include <LINK/stkWrapper/MatrixWrapper.cpp>
//#endif 

// **********************************************************************
// ** these declarations are necessary to make the linker look for
// ** specializations in src/basic/basicSTkSpecializations.cpp
// **********************************************************************
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>
#include <LINK/stkWrapper/MatrixWrapper.h>
typedef double _double;
typedef MatrixWrapper<double > _MatrixWrapper_double_;
PRIMITIVE
MatrixWrapper<_double>::makeFilledLinkMatrix(SCM row, SCM col,  SCM e);
PRIMITIVE
MatrixWrapper<double>::fillLinkMatrix(SCM l, SCM e);
PRIMITIVE
MatrixWrapper<double>::stkList2LinkMatrix(SCM rows, int len);
PRIMITIVE
MatrixWrapper<double>::linkMatrix2STkList(SCM l);
PRIMITIVE
MatrixWrapper<double>::refLinkMatrix(SCM l, SCM i, SCM j);
PRIMITIVE
MatrixWrapper<double>::setLinkMatrix(SCM alist, int len);

#endif 
